# Generated by Django 4.1.4 on 2023-01-24 12:54

import ckeditor.fields
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="DataLink",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(blank=True, max_length=1000)),
                (
                    "target_ressource",
                    models.CharField(blank=True, max_length=1000, null=True),
                ),
                ("size", models.BigIntegerField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name="ISAObject",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=1000)),
                ("description", ckeditor.fields.RichTextField(blank=True, null=True)),
                ("date_created", models.DateTimeField(blank=True, null=True)),
                ("date_modified", models.DateTimeField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name="Profile",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("vault_id", models.CharField(blank=True, max_length=100)),
                (
                    "user",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Publication",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("doi", models.CharField(max_length=100)),
                ("version", models.CharField(max_length=3)),
                ("url", models.CharField(max_length=1000)),
                ("date_created", models.DateTimeField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name="Tool",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(blank=True, max_length=100, null=True)),
                ("connector", models.CharField(blank=True, max_length=100, null=True)),
                ("date_created", models.DateTimeField(blank=True, null=True)),
                (
                    "author",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Assay",
            fields=[
                (
                    "isaobject_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="core.isaobject",
                    ),
                ),
            ],
            bases=("core.isaobject",),
        ),
        migrations.CreateModel(
            name="Investigation",
            fields=[
                (
                    "isaobject_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="core.isaobject",
                    ),
                ),
            ],
            bases=("core.isaobject",),
        ),
        migrations.CreateModel(
            name="ToolStateProfile",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "asyncTask",
                    models.CharField(
                        choices=[
                            ("on", "Asynchronous Task allowed"),
                            ("off", "Asynchronous Task not allowed"),
                        ],
                        max_length=3,
                    ),
                ),
                (
                    "profile",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="core.profile",
                    ),
                ),
                (
                    "tool",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="core.tool",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Toolparam",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("key", models.CharField(blank=True, max_length=100, null=True)),
                ("value", models.CharField(blank=True, max_length=100, null=True)),
                (
                    "tool_id",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="core.tool",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Member",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "permission",
                    models.CharField(
                        choices=[
                            ("admin", "Administrator"),
                            ("contributor", "Contributor"),
                            ("collaborator", "Collaborator"),
                        ],
                        max_length=12,
                    ),
                ),
                (
                    "profiles",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="core.profile"
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="isaobject",
            name="author",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to="core.profile",
            ),
        ),
        migrations.AddField(
            model_name="isaobject",
            name="datalink",
            field=models.ManyToManyField(to="core.datalink"),
        ),
        migrations.AddField(
            model_name="datalink",
            name="author",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to="core.profile",
            ),
        ),
        migrations.AddField(
            model_name="datalink",
            name="publication",
            field=models.ManyToManyField(to="core.publication"),
        ),
        migrations.AddField(
            model_name="datalink",
            name="tool_id",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to="core.tool",
            ),
        ),
        migrations.CreateModel(
            name="Study",
            fields=[
                (
                    "isaobject_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="core.isaobject",
                    ),
                ),
                ("assays", models.ManyToManyField(blank=True, to="core.assay")),
            ],
            bases=("core.isaobject",),
        ),
        migrations.CreateModel(
            name="Project",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=100)),
                ("description", ckeditor.fields.RichTextField(blank=True, null=True)),
                ("member", models.ManyToManyField(to="core.member")),
                ("investigation", models.ManyToManyField(to="core.investigation")),
            ],
        ),
        migrations.AddField(
            model_name="investigation",
            name="members",
            field=models.ManyToManyField(to="core.member"),
        ),
        migrations.AddField(
            model_name="investigation",
            name="studies",
            field=models.ManyToManyField(to="core.study"),
        ),
        migrations.AddField(
            model_name="investigation",
            name="tools",
            field=models.ManyToManyField(to="core.tool"),
        ),
    ]
